
(* Syntaxe abstraite pour le langage Arith - phase génération de code *)

open Base

type local = Local | Global

type program = decl list 
and decl = decl_raw loc
and expr = expr_raw loc

and decl_raw = 
  | Vdecl of string * expr 
  | Fdecl of string * string list * expr

and expr_raw = 
  | Cst of cte
  | Var of local * string
  | Binop of op * expr * expr
  | Letin of string * expr * expr
  | If of expr * expr * expr
  | Call of string * expr list
